; gearbox8.ASM
; Author: 		Ziyang Meng
; Affiliation: 	Dalian University of Technology
; Student ID:	20221071355

DATA SEGMENT PAGE
L8255_A		EQU 220H	; 8255 A Port Input
L8255_B		EQU 221H	; 8255 B Port
L8255_C		EQU 222H	; 8255 C Port Output
L8255_CTL	EQU 223H	; 8255 Control Port
MES_0	DB 'K1: START', 0AH, 0DH, 'K0: REVERSE', 0AH, 0DH, '$'
MES_1	DB 'GEAR 1', 0AH, 0DH, '$'
MES_2	DB 'GEAR 2', 0AH, 0DH, '$'
MES_3	DB 'GEAR 3', 0AH, 0DH, '$'
MES_4	DB 'GEAR 4', 0AH, 0DH, '$'
MES_5	DB 'GEAR 5', 0AH, 0DH, '$'
MES_6	DB 'GEAR 6', 0AH, 0DH, '$'
MES_R	DB 'REVERSE', 0AH, 0DH, '$'
SPEED	DB 7, 6, 5, 4, 3, 2
SPEED_BUF	DB ?
ROWL	EQU 230H		; 16x16 Row lower 8 bits port address
ROWH	EQU 240H		; 16x16 Row higher 8 bits port address
COLL	EQU 250H		; 16x16 Lines lower 8 bits port address
COLH	EQU 260H		; 16x16 Lines higher 8 bits port address
HCODE1 	DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH
		DB 0FFH, 0FFH, 0FFH, 0FFH, 0F7H, 0DFH, 007H, 0C0H
		DB 003H, 0C0H, 0FFH, 0DFH, 0FFH, 0FFH, 0FFH, 0FFH
		DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH
HCODE2	DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH
		DB 0CFH, 0DFH, 0C7H, 0CFH, 0F3H, 0C7H, 0FBH, 0D3H
		DB 0FBH, 0D9H, 0F3H, 0DCH, 007H, 0DEH, 00FH, 0C7H
		DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH
HCODE3 	DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH
		DB 0EFH, 0F7H, 0E7H, 0E7H, 0F3H, 0CFH, 07BH, 0DFH
		DB 07BH, 0DFH, 033H, 0CEH, 087H, 0E0H, 0CFH, 0F1H
		DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH
HCODE4 	DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0F9H
		DB 07FH, 0F8H, 03FH, 0FAH, 08FH, 0FBH, 0E7H, 0DBH
		DB 003H, 0C0H, 001H, 0C0H, 0FFH, 0DBH, 0FFH, 0FBH
		DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH
HCODE5 	DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH
		DB 003H, 0F7H, 003H, 0E7H, 03BH, 0CFH, 0BBH, 0DFH
		DB 0BBH, 0DFH, 03BH, 0CFH, 07BH, 0E0H, 0FBH, 0F0H
		DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH
HCODE6 	DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH
		DB 00FH, 0F0H, 007H, 0E0H, 073H, 0CFH, 0BBH, 0DFH
		DB 0BBH, 0DFH, 033H, 0CFH, 067H, 0E0H, 0EFH, 0F0H
		DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH
HCODER 	DB 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FFH, 0FBH, 0DFH
		DB 003H, 0C0H, 003H, 0C0H, 0FBH, 0DEH, 0FBH, 0FEH
		DB 0FBH, 0FCH, 0FBH, 0F8H, 073H, 0E2H, 007H, 0C3H
		DB 08FH, 0CFH, 0FFH, 0DFH, 0FFH, 0FFH, 0FFH, 0FFH
DATA ENDS

SSG SEGMENT PAGE STACK
	DW 100 DUP(?)
SSG ENDS

CODE SEGMENT PAGE
    ASSUME CS: CODE, DS: DATA, SS: SSG

Start:
	MOV DS, AX
    MOV AX, DATA
    MOV DS, AX
    MOV DX, L8255_CTL
    MOV AL, 90H
    OUT DX, AL			; 8255 A INPUT, C OUTPUT   
	MOV AL, 33H
    MOV DX, L8255_C
    OUT DX, AL

Judge1:
	MOV DX, L8255_A
	IN  AL, DX			; Read the value of switches
	MOV BL, AL
	CMP BL, 00H
	JNE Judge1_next1
	LEA DX, MES_0		; Display MES_0
    MOV AH, 09
    INT 21H
    JMP Judge1
Judge1_next1:
	CMP BL, 01H
	JE  Motor_Reverse	; K0 on, move reverse
	CMP BL, 02H
	JE  Motor_Forward	; K1 on, move forward
	JMP Judge1

Motor_Reverse:
	; BL (value of switches)
	LEA DX, MES_R		; Display MES_R
    MOV AH, 09
    INT 21H
Motor_Reverse_next1:
	MOV DX, L8255_C
	MOV AL, 01H
	OUT DX, AL
	CALL Delay_Reverse
	MOV AL, 03H
	OUT DX, AL
	CALL Delay_Reverse
	MOV AL, 02H
	OUT DX, AL
	CALL Delay_Reverse
	MOV AL, 06H
	OUT DX, AL
	CALL Delay_Reverse
	MOV AL, 04H
	OUT DX, AL
	CALL Delay_Reverse
	MOV AL, 0CH
	OUT DX, AL
	CALL Delay_Reverse
	MOV AL, 08H
	OUT DX, AL
	CALL Delay_Reverse
	MOV AL, 09H
	OUT DX, AL
	CALL Delay_Reverse

	LEA SI, HCODER
	CALL Dot_Array
	MOV DX, L8255_A
	IN  AL, DX			; Read the value of switches
	MOV BL, AL
	CMP BL, 01H			; K0 still on, keep reversing
	JE Motor_Reverse_next1
	CMP BL, 00H			; K0 off, back to Judge1
	JE Judge1

Motor_Forward:
	; BL: Value of Switches
	CMP BL, 00H			; K1 off, back to Judge 1
	JE Judge1
	CMP BL, 02H			; K1 off, back to Judge 1
	JE Motor_Forward_g1
	CMP BL, 06H			; K1 off, back to Judge 1
	JE Motor_Forward_g2
	CMP BL, 0EH			; K1 off, back to Judge 1
	JE Motor_Forward_g3
	CMP BL, 1EH			; K1 off, back to Judge 1
	JE Motor_Forward_g4
	CMP BL, 3EH			; K1 off, back to Judge 1
	JE Motor_Forward_g5
	CMP BL, 7EH			; K1 off, back to Judge 1
	JE Motor_Forward_g6

Motor_Forward_g1:
	LEA DX, MES_1		; Display MES_1
    MOV AH, 09
    INT 21H
    LEA SI, SPEED
    MOV DH, [SI]
    MOV SPEED_BUF, DH
    JMP Motor_Forward_next1
Motor_Forward_g2:
	LEA DX, MES_2		; Display MES_2
    MOV AH, 09
    INT 21H
    LEA SI, SPEED
    MOV DH, [SI + 1]
    MOV SPEED_BUF, DH
    JMP Motor_Forward_next1
Motor_Forward_g3:
	LEA DX, MES_3		; Display MES_3
    MOV AH, 09
    INT 21H
    LEA SI, SPEED
    MOV DH, [SI + 2]
    MOV SPEED_BUF, DH
    JMP Motor_Forward_next1
Motor_Forward_g4:
	LEA DX, MES_4		; Display MES_4
    MOV AH, 09
    INT 21H
    LEA SI, SPEED
    MOV DH, [SI + 3]
    MOV SPEED_BUF, DH
    JMP Motor_Forward_next1
Motor_Forward_g5:
	LEA DX, MES_5		; Display MES_5
    MOV AH, 09
    INT 21H
    LEA SI, SPEED
    MOV DH, [SI + 4]
    MOV SPEED_BUF, DH
    JMP Motor_Forward_next1
Motor_Forward_g6:
	LEA DX, MES_6		; Display MES_6
    MOV AH, 09
    INT 21H
    LEA SI, SPEED
    MOV DH, [SI + 5]
    MOV SPEED_BUF, DH
    JMP Motor_Forward_next1

Motor_Forward_next1:
	MOV DX, L8255_C
	MOV AL, 09H
	OUT DX, AL
	CALL Delay_Forward
	MOV AL, 08H
	OUT DX, AL
	CALL Delay_Forward
	MOV AL, 0CH
	OUT DX, AL
	CALL Delay_Forward
	MOV AL, 04H
	OUT DX, AL
	CALL Delay_Forward
	MOV AL, 06H
	OUT DX, AL
	CALL Delay_Forward
	MOV AL, 02H
	OUT DX, AL
	CALL Delay_Forward
	MOV AL, 03H
	OUT DX, AL
	CALL Delay_Forward
	MOV AL, 01H
	OUT DX, AL
	CALL Delay_Forward

	MOV DX, L8255_A
	IN  AL, DX			; Read the value of switches
	CMP AL, 00H
	JE  Judge1
	CMP AL, 02H
	JE  Motor_Forward_d1
	CMP AL, 06H
	JE  Motor_Forward_d2
	CMP AL, 0EH
	JE  Motor_Forward_d3
	CMP AL, 1EH
	JE  Motor_Forward_d4
	CMP AL, 3EH
	JE  Motor_Forward_d5
	CMP AL, 7EH
	JE  Motor_Forward_d6
	JMP Motor_Forward

Motor_Forward_d1:
	LEA SI, HCODE1
	CALL Dot_Array
	CMP AL, BL			; Test if the input keys have changed
	JNE Motor_Forward_next2
	JMP Motor_Forward_next1
Motor_Forward_d2:
	LEA SI, HCODE2
	CALL Dot_Array
	CMP AL, BL			; Test if the input keys have changed
	JNE Motor_Forward_next2
	JMP Motor_Forward_next1
Motor_Forward_d3:
	LEA SI, HCODE3
	CALL Dot_Array
	CMP AL, BL			; Test if the input keys have changed
	JNE Motor_Forward_next2
	JMP Motor_Forward_next1
Motor_Forward_d4:
	LEA SI, HCODE4
	CALL Dot_Array
	CMP AL, BL			; Test if the input keys have changed
	JNE Motor_Forward_next2
	JMP Motor_Forward_next1
Motor_Forward_d5:
	LEA SI, HCODE5
	CALL Dot_Array
	CMP AL, BL			; Test if the input keys have changed
	JNE Motor_Forward_next2
	JMP Motor_Forward_next1
Motor_Forward_d6:
	LEA SI, HCODE6
	CALL Dot_Array
	CMP AL, BL			; Test if the input keys have changed
	JNE Motor_Forward_next2
	JMP Motor_Forward_next1

Motor_Forward_next2:	;  Keys have been changed
	MOV BL, AL
	JMP Motor_Forward


	Delay_Reverse PROC
	PUSH AX
	PUSH BX
	PUSH CX
	PUSH DX

	LEA BX, SPEED
	MOV DH, [BX]
X1: MOV CX, 0120H
X2: LOOP X2
	DEC DH
	JNZ X1
	POP DX
	POP CX
	POP BX
	POP AX
	RET
	
	Delay_Reverse ENDP

	Delay_Forward PROC
	PUSH AX
	PUSH CX
	PUSH DX

	MOV DH, SPEED_BUF
X3: 
	MOV CX, 0120H
X4: 
	LOOP X4
	DEC DH
	JNZ X3

	POP DX
	POP CX
	POP AX
	RET
	
	Delay_FORWARD ENDP


	Dot_Array PROC
	; SI: Address of character's hillcode
	PUSH AX
	PUSH BX
	PUSH CX
	PUSH DX

    MOV DX, COLL
    MOV AL, 00H
    OUT DX, AL
    MOV DX, COLH
    OUT DX, AL
    MOV AL, 0FFH
    MOV DX, ROWL
    OUT DX, AL
    MOV DX, ROWH
    OUT DX, AL 			
 
	CALL Dot_Array_Display

	POP DX
	POP CX
	POP BX
	POP AX
	
	RET
	Dot_Array ENDP


	Dot_Array_Display PROC
	PUSH SI
	PUSH AX
	PUSH BX
	PUSH CX
	PUSH DX
    MOV BL, 01H   		; bit-choose, initial value
    MOV CX, 08H 		; 8 times*(1 lower line + 1 higher line)
Dot_Array_Display_loop1:	; Lower 8 columns
	MOV DX, COLL           
    MOV AL, 00H
    OUT DX, AL
    MOV AL, [SI]
    MOV DX, ROWL            
    OUT DX, AL
    INC SI
    MOV AL, [SI] 
    MOV DX, ROWH            
    OUT DX, AL
    INC SI
    MOV DX, COLL            
    MOV AL, BL
    OUT DX, AL
    ROL BL, 1
    CALL Dot_Array_Delay
    LOOP Dot_Array_Display_loop1
    MOV DX, COLL
    MOV AL, 00H
    OUT DX, AL
    MOV CX, 08H 		; 8 times*(1 lower line + 1 higher line)
Dot_Array_Display_loop2:	; Higher 8 columns
	MOV DX, COLH           
    MOV AL, 00H
    OUT DX, AL
    MOV AL, [SI] 
    MOV DX, ROWL           
    OUT DX, AL
    INC SI
    MOV AL, [SI]
    MOV DX, ROWH            
    OUT DX, AL
    INC SI
    MOV DX, COLH        
    MOV AL, BL
    OUT DX, AL
    ROL BL, 1
    CALL Dot_Array_Delay
    LOOP Dot_Array_Display_loop2
    MOV DX, COLL
    MOV AL, 00H 
    OUT DX, AL 
    POP DX
    POP CX
    POP BX
    POP AX
    POP SI

    RET
	Dot_Array_Display ENDP


	Dot_Array_Delay PROC
	PUSH CX
	MOV CX, 80H 
Dot_Array_Delay_loop1:
	LOOP Dot_Array_Delay_loop1
	POP CX

	RET
	Dot_Array_Delay ENDP

	
CODE ENDS
	END Start
